﻿# STM32G474E-EVAL1 Evaluation  kit

## Overview

The STM32G474E-EVAL1 board is a complete demonstration and development platform for the STMicroelectronics Arm® Cortex®-M4 core-based STM32G474QET6 microcontroller, designed to make user application development easier.

STM32G474E-EVAL1 features a motor-control configuration board. STM32G484E-EVAL features the STM32G484QET6 microcontroller with cryptography.
The full range of hardware features available on the board helps the users to improve application development to evaluate all the peripherals (USB FS, UCPD, USART, Audio, ADC and DAC, differential ADC, TFT LCD, Potentiometer/LDR, SRAM, Quad-SPI flash memory device, microSD™ card, smartcard, CAN‑FD transceiver, High Brightness LED, motor-control connectors, temperature sensor, and others). Extension headers provide an easy connection to daughterboards for specific applications.

The board features STLINK-V3E as the embedded in-circuit debugger and programmer, for the STM32 MCU and the USB Virtual COM port bridge.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um2514-evaluation-board-with-stm32g4xxqe-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32G484QE microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32g484qe.html)
- [STM32G474E-EVAL1 board](https://www.st.com/en/evaluation-tools/stm32g474e-eval1.html)
- [User manual](https://www.st.com/resource/en/user_manual/um2514-evaluation-board-with-stm32g4xxqe-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/stm32g474e-eval1.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/mb1397-g474e-b04_schematic.pdf)
